/*
This is a part of the IconDesk source code.

Copyright (C) 2003 Erik Christiansson, aka Sci
www.alphafish.com
erik@alphafish.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef __MAIN_H
#define __MAIN_H

#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include <list>
#include "..\lsapi\lsapi.h"
#include "Group.h"
#include "tooltips.h"

using namespace std;

typedef list<Group*> GroupList;
typedef GroupList::iterator GroupListIter;

WNDPROC oldWndProc;
DWORD oldClassStyle;
UINT timerID;
GroupList groups;
HINSTANCE hInst;
HWND desktopWnd;
HWND tooltipWnd;
UINT tooltipCounter;

void loadGroups();
void addGroup(const char* name);
void deleteGroups();
Group* getGroup(const char* name);

LRESULT wndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

void bangShow(HWND caller, LPCSTR args);
void bangHide(HWND caller, LPCSTR args);
void bangToggle(HWND caller, LPCSTR args);
void bangUpdate(HWND caller, LPCSTR args);

extern "C" {
	__declspec( dllexport ) int initModuleEx(HWND hParentWnd, HINSTANCE hInstance, LPCSTR szPath);
	__declspec( dllexport ) void quitModule(HINSTANCE hInstance);
}

#endif __MAIN_H
